 /**
 * The Interval specification.
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 * 
 * @author Gloss
 * @version 1.1 - 23/Mar/2013 mal
 **/
 
 specification Interval[TotalOrderWithSuc]
 
  sorts
    Interval[Successorable]
    
  constructors
    interval: Successorable Successorable -->? Interval[Successorable];
    
  observers
    sup: Interval[Successorable] --> Successorable;
    inf: Interval[Successorable] --> Successorable;
    
  others
    before: Interval[Successorable] Interval[Successorable];
    elements: Interval[Successorable] --> SortedSet[Successorable];

  domains
    E, F: Successorable;
    interval(E,F) if geq(F,E);
    
  axioms
    E,F: Successorable; 
    I,J: Interval[Successorable];
    
    sup(interval(E, F)) = F;
    inf(interval(E, F)) = E;
    
    before(I, J) iff geq(inf(J), sup(I));
    
    elements(I) = insert(empty(), inf(I)) if sup(I) = inf(I);
    elements(I) = insert(elements(interval(suc(inf(I)), sup(I))), inf(I)) 
    											if not (sup(I) = inf(I));
end specification