 /**
 * The interface IOrderable, representing a notion of
 * greater than or equal
 *
 * @param <H> - the type 
 *
 * @author Gloss
 * @version 1.1 - 27/Nov/2012 jb
 **/
interface IOrderable<H> extends Cloneable {
	
	/**
	 * Is the this greater or equal than the given element?
	 * 
	 * @param e - the element to compare
	 * @return true if this is greater or equal, false otherwise
	 */
	boolean isGreaterEq(H e);
	
	/**
	 * Makes a copy of the object
	 * 
	 * @return clone of the object
	 */
	IOrderable<H> clone();
}