/**
 * A class that defines integers as implementing Successorable.
 * 
 * @author Gloss
 * @version 1.1 - 27/Nov/2012 jb
 **/
public class MyInteger implements Successorable<MyInteger>  {
	
	/**
	 * The integer number represented
	 */
	private int number;

	/**
	 * Constructor
	 * @param value - the value of MyInteger
	 */
	public MyInteger(int value){
		number = value;
	}
	
	/**
	 * Returns the successor to this MyInteger
	 * 
	 * @return the next MyInteger
	 */
	public MyInteger suc() {
		return new MyInteger(number+1);
	}

	/**
	 * Compares this MyInteger to another
	 * 
	 * @param arg - the MyInteger to be compared
	 * @return -1 if this MyInteger is less than other
	 * 		    0 if this MyInteger is equal to other
	 *          1 if this MyInteger is greater than other
	 */
	public int compareTo(MyInteger arg) {
		return (number < arg.number) ? -1 : (number == arg.number ? 0 : 1);
	}
	
	/**
	 * Textual representation of MyInteger
	 * 
	 * @return String representing MyInteger
	 */
	public String toString(){
		return "" + number;
	}

	/**
	 * Is the this greater or equal than the given MyInteger?
	 * 
	 * @param e - the element to compare
	 * @return true if this is greater or equal, false otherwise
	 */
	public boolean isGreaterEq(MyInteger e) {
		return (this.number >= e.number);
	}
	
	/**
	 * Makes a copy of MyInteger
	 * 
	 * @return clone of MyInteger
	 */
	public MyInteger clone(){
		return this;
	}
	
	/**
	 * Returns the hash code for this MyInteger
	 * 
	 * @return hash code for this MyInteger
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + number;
		return result;
	}

	/**
	 * Is the object equal to this MyInteger
	 * 
	 * @param obj - the object to compare
	 * @return true if they are equal, false otherwise
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MyInteger other = (MyInteger) obj;
		if (number != other.number)
			return false;
		return true;
	}
}
